<?php
class StudentController extends BaseController {
	// 首页
	function actionIndex(){
		$this->page_title='学生';

		//获取所教班级数据
		$condition2 = array(
			"teacher_id" => $_SESSION["u_id"]
		);
		$classes = new Classes();
		$this->classes_data = $classes->findAll($condition2);
		$top_classes = $classes->find($condition2,"classes_number","classes_id");		


		if (arg("classes")) {
			$classes_id = arg("classes_id",$_COOKIE["classes"]);
		} else {
			$classes_id = arg("classes_id",$top_classes["classes_id"]);
		}

		if (arg("student_find")) {
			$condition = array(
				"classes_id = :c1 AND student_name like :c2",
				":c1" => $classes_id,
				":c2" => '%'.arg("student_find").'%',
			);
		} else {
			$condition = array(
				"classes_id" => $classes_id
			);
		}

		//获取学生数据
		$this->classes_id = $classes_id;
		$this->table_name = 'student';		
		$this->page = (int)arg("p", 1);
		$this->record_num = arg("j", 10); //		
		$student = new Student();
		$this->student_data = $student->findAll($condition, "student_number", "*", array($this->page, $this->record_num, 4));
		$this->pager = $student->page;


	}
	

	function actionPhoto(){
		$this->page_title='学生照片';

		//获取所教班级数据
		$condition2 = array(
			"teacher_id" => $_SESSION["u_id"]
		);
		$classes = new Classes();
		$this->classes_data = $classes->findAll($condition2);
		$top_classes = $classes->find($condition2,"classes_number","classes_id");
		if (arg("classes")) {
			$classes_id = arg("classes_id",$_COOKIE["classes"]);
		} else {
			$classes_id = arg("classes_id",$top_classes["classes_id"]);
		}

		//获取学生数据
		$condition = array(
			"classes_id" => $classes_id
		);
		$this->classes_id = $classes_id;
		$student = new Student();
		$this->student_data = $student->findAll($condition, "student_number", "*");


		$this->display("teacher/student_photo.html");
	}

	//上传学生头像
	function actionAvatarupload(){
		$this->page_title='上传学生头像';
		$this->display("photo.html");
	}


	//清除avatar的cookie
	function actionReturn(){
		//$this->page_title='上传学生头像';
		setcookie("avatar","",time()-3600,"/");
		$this->jump(url("teacher/student","photo",array("classes_id"=>arg("classes_id"))));
	}

	//创建数据
	function actionCreate(){
		$this->page_title='新增学生数据';
	}

	//数据入库
	function actionAdd(){
		//首先判断传值是否为空
		if (arg("student_name")) {

			$data = array(
			"student_name" => arg("student_name"),
			"student_sex" => arg("student_sex"),
			"classes_id" => arg("classes_id"),
			"grade_id" => arg("grade_id"),
			"room_id" => arg("room_id"),
			"student_number" => arg("student_number"),
			"seat_id" => arg("seat_id"),
			"group_id" => arg("group_id"),
			"is_group_leader" => arg("is_group_leader"),
			"student_password" => md5("123456"),
			);
			$student = new Student();
			$student->create($data);

			$this->tips("数据已添加成功！",url("teacher/student","index"));
		}
		else
		{
			$this->tips("错误：没有需要添加的数据！",url("teacher/student","index"));

		}

	}	

	//编辑数据
	function actionEdit(){
		$this->page_title='编辑学生数据';
		$this->classes_id = arg("classes_id");
		if (arg("id")) {
			$student = new Student();
			$this->student_data = $student->find(array("student_id" =>arg("id" )));
		}else{
			$this->tips("错误：没有需要编辑的数据",url("teacher/student","index"));			
		}
	}

	//更新数据
	function actionUpdate(){
		if (arg("id")) {
			$data = array(
			"student_name" => arg("student_name"),
			"student_sex" => arg("student_sex"),
			"student_number" => arg("student_number"),
			"classes_id" => arg("classes_id"),
			"seat_id" => arg("seat_id"),
			"group_id" => arg("group_id"),
			"is_group_leader" => arg("is_group_leader"),
			);
			$student = new Student();
			$student->update(array("student_id" =>arg("id")),$data);
			$this->tips("数据已成功更新！",url("teacher/student","index",array("classes_id"=>arg("classes_id"))));
		}
		else
		{
			$this->tips("错误：没有需要更新的数据！",url("teacher/student","index"));
		}		
	}

	//删除单条数据
	//删除单条数据
	function actionDelete(){
		if (arg("id")) {
			del_student(arg("id"));
			$student_data = array('result' =>"删除成功！",'status' =>0);
			header('Content-type: application/json');
			echo json_encode($student_data); 
			//$this->tips("数据已成功删除！",url("teacher/student","index"));
		}
		else
		{
			$this->tips("错误：没有选择删除的数据！",url("teacher/student","index"));
		}		
	}

	//重置密码
	function actionReset(){
		if (arg("id")) {
			$data = array(
			"student_password" => md5("123456"),
			);
			$student = new Student();
			$student->update(array("student_id" =>arg("id")),$data);
			$student_data = array('result' =>"重置成功！",'status' =>0);
			header('Content-type: application/json');
			echo json_encode($student_data); 			
			//$this->tips("密码已重置为123456",url("teacher/student","index"));
		}
		else
		{
			$this->tips("错误：没有需要重置的数据！",url("teacher/student","index"));
		}		
	}


	//批量操作数据
	function actionBatch(){
		switch (arg("batch")) {
			case 'delete':
				if (arg("sel_box")){
					$student = new Student();
					$del_id=arg("sel_box");
					$del_num=count($del_id);
					$id_str="";//ID字串
					$sql= "DELETE FROM student WHERE student_id in";
		             for($i=0;$i<$del_num;$i++){
		             	$id=$del_id[$i];
		             	$id_str = $id_str."$id,";
		             	//echo $sql;
						del_student($id);
		             }
		            $id_str = rtrim($id_str, ","); //去掉最后一个,号
		            $sql.="(".$id_str.")";
		            //dump($_POST["sel_box"]);
		            $this->result = $student->execute($sql);
		            //header("location:/teacher/student/index");
		           $this->tips("已删除选定部分的同学。",url("teacher/student","index"));
				}else{
					dump(arg("sel_box"));
					$this->tips("出错了，没有需要删除的数据！",url("teacher/student","index"));
				}
				break;
			case 'reset':
				if (arg("sel_box")){
					$reset_id=arg("sel_box");
					foreach ($reset_id as $id) {
						$student = new Student();
						$student->update(array("student_id" =>$id), array('student_password' => md5("123456") ));
					}
					$this->tips("密码已重置为123456",url("teacher/student","index"));
				}else{
					$this->tips("出错了，没有需要重置的数据！",url("teacher/student","index"));
				}
				break;			
			default:
				# code...
				break;
		}
	}


	//批量导入数据
	function actionImport(){
		$this->page_title = '批量导入学生数据';
		//header("Location:/phpoffice/public/import.php");
	}	

	//上传数据表格
	function actionUpload() {
		$up = new FileUpload();
		//设置属性（上传的位置、大小、类型、设置文件名是否要随机生成）
		$up->set("path",APP_DIR."/upload/import/");  //此处路径调试好久都不行，后来加上app_dir即可。晕。
		$up->set("maxsize",10485760); //字节
		$up->set("allowtype",array('xls','xlsx'));//可以是"doc"、"docx"、"xls"、"xlsx"、"csv"和"txt"等文件，注意设置其文件大小
		$up->set("israndname",true);//true:由系统命名；false：保留原文件名
		$up->upload("filename");
		$filename = $up->getFilename();
		header("Location:/phpoffice/public/student_import.php?file=".$filename);
	}

	//学生分组操作
	function actionGroup() {
		$this->page_title = "学生分组";
		//获取所教班级数据
		$condition2 = array(
			"teacher_id" => $_SESSION["u_id"]
		);
		$classes = new Classes();
		$this->classes_data = $classes->findAll($condition2);
		$top_classes = $classes->find($condition2,"classes_number","classes_id");		


		if (arg("classes")) {
			$classes_id = arg("classes_id",$_COOKIE["classes"]);
		} else {
			$classes_id = arg("classes_id",$top_classes["classes_id"]);
		}


			$condition = array(
				"group_id =''  AND classes_id = :c1",
				":c1" => $classes_id,

			);

		//获取学生数据
		$this->classes_id = $classes_id;
		$this->table_name = 'student';		
		$student = new Student();
		$this->student_data = $student->findAll($condition, "student_number", "*");
	}


	//学生荣誉批量操作
	function actionHonor() {
		$this->page_title = "学生荣誉";
		//获取所教班级数据
		$condition2 = array(
			"teacher_id" => $_SESSION["u_id"]
		);
		$classes = new Classes();
		$this->classes_data = $classes->findAll($condition2);
		$top_classes = $classes->find($condition2,"classes_number","classes_id");		


		if (arg("classes")) {
			$classes_id = arg("classes_id",$_COOKIE["classes"]);
		} else {
			$classes_id = arg("classes_id",$top_classes["classes_id"]);
		}


			$condition = array(
				"classes_id = :c1",
				":c1" => $classes_id,

			);

		//获取学生数据
		$this->classes_id = $classes_id;
		$this->table_name = 'student';		
		$student = new Student();
		$this->student_data = $student->findAll($condition, "student_point DESC", "*");
	}	


	//写入学生荣誉数据
	function actionHonorAdd() {
		$classes_id = arg("classes_id");
		$honor = new Honor();
		$term_id = config("term_id");
		//首先判断传值是否为空
		if (arg("sel_box")){
			$sql = "";
			$add_id=arg("sel_box");
			$add_num=count($add_id);
             for($i=0;$i<$add_num;$i++){
             	$id=$add_id[$i];
             	$student_name = id2name("student",$id,"student_name");
             	$sql = $sql."INSERT INTO honor
             	(student_id,student_name,honor_type,term_id)
             	VALUES
             	($id,'".$student_name."','信息技术小能手',$term_id);";
             } 		         
           $honor->execute($sql);
            dump($sql);
            $this->tips("荣誉添加成功！",url("teacher/student","honor",array("classes_id"=>$classes_id)));
            //dump($sql);
		}else{
			$this->tips("错误：没有选择学生",url("teacher/student","honor",array("classes_id"=>$classes_id)));
		} 
	}

	//写入学生分组数据
	function actionGroupSet() {
		$classes_id = arg("classes_id");
		$group_id = arg("group_id");
		$group_name = arg("group_name");
		$student = new Student();
		//首先判断传值是否为空
		if (arg("sel_box")){
			$update_id=arg("sel_box");
			$update_num=count($update_id);
			$id_str="";//ID字串

			$sql= "UPDATE student SET group_id='$group_id',group_name='$group_name'  WHERE student_id in";
             for($i=0;$i<$update_num;$i++){
             	$id=$update_id[$i];
              	$id_str = $id_str."$id,";
             }
            $id_str = rtrim($id_str, ","); //去掉最后一个,号
            $sql.="(".$id_str.")";
  		         
            $student->execute($sql);
            $this->tips("分组设置成功！",url("teacher/student","group",array("classes_id"=>$classes_id)));
            //dump($sql);
		}else{
			$this->tips("错误：没有选择学生",url("teacher/student","group",array("classes_id"=>$classes_id)));
		} 
	}

	//是否组长
	function actionLeaderajax() {
		 $student_id = arg("student_id");
		 $student = new Student();
		if(id2name('student',$student_id,'is_group_leader')==1) {
			echo "<a  class='text-danger'><i class='fa fa-toggle-off'> 否</i></a>";
			$student->update(array('student_id' =>$student_id,),array('is_group_leader'=>0));
		} else {
			echo "<a class='text-success' ><i class='fa fa-toggle-on'> 是</i></a>";
			$student->update(array('student_id' =>$student_id,),array('is_group_leader'=>1));
		}		 
	}

	//导出学生
	function actionExport()	{
	new PhpOffice\PhpSpreadsheet\Spreadsheet;
	new PhpOffice\PhpSpreadsheet\Writer\Xlsx;
	$spreadsheet = new Spreadsheet();
	$worksheet = $spreadsheet->getActiveSheet();
	$worksheet->setTitle('学生表');

	//表头
	//设置单元格内容
	$worksheet->setCellValueByColumnAndRow(1, 1, '学生表');
	$worksheet->setCellValueByColumnAndRow(1, 2, '姓名');
	$worksheet->setCellValueByColumnAndRow(2, 2, '性别');
	$worksheet->setCellValueByColumnAndRow(3, 2, '班号');
	$worksheet->setCellValueByColumnAndRow(4, 2, '座位');
	$worksheet->setCellValueByColumnAndRow(5, 2, '分组');

	//合并单元格
	$worksheet->mergeCells('A1:E1');
    $styleArray = [
	   	 'font' => [
	    	'bold' => true
	     ],
	       'alignment' => [
	            'horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER,
	        ],
	    ];
	    //设置单元格样式
	    $worksheet->getStyle('A1')->applyFromArray($styleArray)->getFont()->setSize(28);

	    $worksheet->getStyle('A2:E2')->applyFromArray($styleArray)->getFont()->setSize(14);
	    //$worksheet->getStyle('A2:D2')->getFont()->setSize(14);

	    $student = new Student();
	    //读取数据
	    $sql = "SELECT student_name,student_sex,classes_id,seat_id,student_group FROM `student`";
	    $stmt = $student->query($sql);
	    $rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
	    $len = count($rows);
	    $j = 0;
	    for ($i=0; $i < $len; $i++) { 
	        $j = $i + 3;
	        $worksheet->setCellValueByColumnAndRow(1, $j, $rows[$i]['student_name']);
	        $worksheet->setCellValueByColumnAndRow(2, $j, $rows[$i]['student_sex']);
	        $worksheet->setCellValueByColumnAndRow(3, $j, $rows[$i]['classes_id']);
	        $worksheet->setCellValueByColumnAndRow(4, $j, $rows[$i]['seat_id']);
	        $worksheet->setCellValueByColumnAndRow(5, $j, $rows[$i]['student_group']);
	    }


	    $styleArrayBody = [
	        'borders' => [
	            'allBorders' => [
	                'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
	                'color' => ['argb' => '666666'],
	            ],
	        ],
	        'alignment' => [
	            'horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER,
	        ],
	    ];
	    $total_rows = $len + 2;
	    //添加所有边框/居中
	    $worksheet->getStyle('A1:E'.$total_rows)->applyFromArray($styleArrayBody);


	// 下载
	$filename = 'student.xlsx';

	header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
	header('Content-Disposition: attachment;filename="'.$filename.'"');
	header('Cache-Control: max-age=0');

	$writer = \PhpOffice\PhpSpreadsheet\IOFactory::createWriter($spreadsheet, 'Xlsx');
	$writer->save('php://output');
	}
}