<?php 
require '../vendor/autoload.php';

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

include('conn.php');

$spreadsheet = new Spreadsheet();
$worksheet = $spreadsheet->getActiveSheet();
$worksheet->setTitle('学生表');

//表头
//设置单元格内容
$worksheet->setCellValueByColumnAndRow(1, 1, '学生表');
$worksheet->setCellValueByColumnAndRow(1, 2, 'id');
    $worksheet->setCellValueByColumnAndRow(2, 2, '姓名');
    $worksheet->setCellValueByColumnAndRow(3, 2, '性别');
    $worksheet->setCellValueByColumnAndRow(4, 2, '学号');
    $worksheet->setCellValueByColumnAndRow(5, 2, '班级');
    $worksheet->setCellValueByColumnAndRow(6, 2, '积分');

    //合并单元格
    $worksheet->mergeCells('A1:F1');

    $styleArray = [
        'font' => [
            'bold' => true
        ],
        'alignment' => [
            'horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER,
        ],
    ];
    //设置单元格样式
    $worksheet->getStyle('A1')->applyFromArray($styleArray)->getFont()->setSize(28);

    $worksheet->getStyle('A2:F2')->applyFromArray($styleArray)->getFont()->setSize(14);
    //$worksheet->getStyle('A2:D2')->getFont()->setSize(14);


    //读取数据
    $sql = "SELECT student_id,student_name,student_sex,student_number,classes_id,student_point FROM `student`";
    $stmt = $db->query($sql);
    $rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
    $len = count($rows);
    $j = 0;
    for ($i=0; $i < $len; $i++) { 
        $j = $i + 3;
        $worksheet->setCellValueByColumnAndRow(1, $j, $rows[$i]['student_id']);
        $worksheet->setCellValueByColumnAndRow(2, $j, $rows[$i]['student_name']);
        $worksheet->setCellValueByColumnAndRow(3, $j, $rows[$i]['student_sex']);
        $worksheet->setCellValueByColumnAndRow(4, $j, $rows[$i]['student_number']);
        $worksheet->setCellValueByColumnAndRow(5, $j, $rows[$i]['classes_id']);
        $worksheet->setCellValueByColumnAndRow(6, $j, $rows[$i]['student_point']);
    }


    $styleArrayBody = [
        'borders' => [
            'allBorders' => [
                'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
                'color' => ['argb' => '666666'],
            ],
        ],
        'alignment' => [
            'horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER,
        ],
    ];
    $total_rows = $len + 2;
    //添加所有边框/居中
    $worksheet->getStyle('A1:F'.$total_rows)->applyFromArray($styleArrayBody);


// 下载
$filename = 'student_export.xlsx';

header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment;filename="'.$filename.'"');
header('Cache-Control: max-age=0');

$writer = \PhpOffice\PhpSpreadsheet\IOFactory::createWriter($spreadsheet, 'Xlsx');
$writer->save('php://output');
?>